/*
 *++
COPYRIGHT:
This file is part of the GSM Suite, a set of programs for
manipulating state machines in a graphical fashion.
Copyright (C) 1996, 1997  G. Andrew Mangogna.

LICENSE:
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the
Free Software Foundation, Inc.,
59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

MODULE:

$RCSfile: ExposeCommand.cc,v $
$Revision: 1.8 $
$Date: 1997/07/02 04:45:03 $

ABSTRACT:

CONDITIONAL COMPILATION:

MODIFICATION HISTORY:
$Log: ExposeCommand.cc,v $
Revision 1.8  1997/07/02 04:45:03  andrewm
Added copyright and license notices to the tops of the files.

Revision 1.7  1997/03/04 06:32:51  andrewm
Another check point.  The editor can draw output from files.
The crashing during the dtor for MachineGroup is fixed.

Revision 1.6  1997/02/23 23:44:11  andrewm
Checkpoint.  Things seem to be working reasonably well.

Revision 1.5  1996/11/17 21:50:51  andrewm
Converting to the new version of g++ (2.7.2) and now everything
is under CVS.

// Revision 1.4  1996/09/22  01:47:02  andrewm
// pre-alpha release
//
// Revision 1.4  1996/09/22  01:47:02  andrewm
// pre-alpha release
//
// Revision 1.3  1996/08/05  01:27:42  andrewm
// checkpoint
//
// Revision 1.3  1996/08/05  01:27:42  andrewm
// checkpoint
//
// Revision 1.2  1996/07/27  20:58:52  andrewm
// checkpoint
//
// Revision 1.1  1996/07/15  01:22:32  andrewm
// Initial revision
//
 *--
 */

/*
PRAGMAS
*/
#ifdef __GNUG__
#	pragma implementation
#endif /* __GNUG__ */

/*
INCLUDE FILES
*/
#include <assert.h>

#include "Document.h"
#include "ExposeCommand.h"
#include "GraphicRenderer.h"

/*
MACRO DEFINITIONS
*/

/*
TYPE DEFINITIONS
*/

/*
EXTERNAL FUNCTION REFERENCES
*/

/*
FORWARD FUNCTION REFERENCES
*/

/*
FORWARD CLASS REFERENCES
*/

/*
EXTERNAL DATA REFERENCES
*/

/*
EXTERNAL DATA DEFINITIONS
*/

/*
STATIC DATA ALLOCATION
*/
static char rcsid[] = "@(#) $RCSfile: ExposeCommand.cc,v $ $Revision: 1.8 $" ;

/*
STATIC MEMBER DEFINITIONS
*/

/*
FUNCTION DEFINITIONS
*/

void ExposeCommand::
execute(
	XmAnyCallbackStruct *callback_data)
{
	XmDrawingAreaCallbackStruct *call_data =
		(XmDrawingAreaCallbackStruct *)callback_data ;
	assert(call_data != NULL) ;
	assert(call_data->reason == XmCR_EXPOSE) ;

	XEvent *event = call_data->event ;
	assert(event != NULL) ;
	assert(event->type == Expose) ;

	XExposeEvent *xev = &event->xexpose ;
	Rectangle rect(Point(xev->x, xev->y), xev->width, xev->height) ;
	GraphicRenderer& render = GraphicRenderer::instance() ;
	render.add_rectangle_to_clip(rect) ;

	if (xev->count == 0)
	{
			/*
			Set the clip region in the graphics context
			and redraw the proper area.
			*/
		render.set_clip() ;
		_document->redraw() ;
		render.clear_clip() ;
	}
}
